package com.persagy.controller;


import com.alibaba.fastjson.JSONObject;
import com.googlecode.aviator.AviatorEvaluator;
import com.googlecode.aviator.Expression;
import com.persagy.cache.AlarmInfoCache;
import com.persagy.client.GroupNettyClient;
import com.persagy.entity.NettyMessage;
import com.persagy.repository.AlarmRecordRepository;
import com.persagy.service.AlarmHandleService;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Arrays;
import java.util.HashMap;

@Api(tags = "hello")
@RestController
@RequestMapping("hello")
@Slf4j
public class HelloWorld {
    @Autowired
    AlarmHandleService alarmHandleService;

    @Autowired
    private GroupNettyClient groupNettyClient;
    @Autowired
    AlarmInfoCache alarmInfoCache;
    @Autowired
    AlarmRecordRepository alarmRecordRepository;

    @PostMapping("/")
    public String world(@RequestBody JSONObject jsonObject) throws Exception {
        return "hello world!";
    }

    @PostMapping("/testMesage")
    public String testMesage(@RequestBody JSONObject jsonObject) throws Exception {
        NettyMessage nettyMessage = new NettyMessage(groupNettyClient.projectId);
        nettyMessage.setRemark("连接已经建立；");
        nettyMessage.setOpCode(4);
        JSONObject content = new JSONObject();
        content.put("groupCode", groupNettyClient.groupCode);
        content.put("projectId", groupNettyClient.projectId);
        nettyMessage.setContent(Arrays.asList(content));
        groupNettyClient.sendMessage(nettyMessage.toString());
        return "成功";
    }

    @PostMapping("/testMesage5")
    public String testMesage5(@RequestBody JSONObject jsonObject) throws Exception {
        NettyMessage nettyMessage = new NettyMessage(groupNettyClient.projectId);
        nettyMessage.setRemark("连接已经建立；");
        nettyMessage.setOpCode(5);
        jsonObject.put("groupCode", groupNettyClient.groupCode);
        jsonObject.put("projectId", groupNettyClient.projectId);
        nettyMessage.setContent(Arrays.asList(jsonObject));
        groupNettyClient.sendMessage(nettyMessage.toString());
        return "成功";
    }

    private static boolean checkExpression(String expression, HashMap<String, Object> paramMap) {
        Expression triggerExp = AviatorEvaluator.compile(expression, false);
        // 执行报警条件公式，得到触发和恢复结果
        return (Boolean) triggerExp.execute(paramMap);
    }

    public static void main(String[] args) {
        String expression = "((ACATAH_FreshAirH!=NaN && ACATAH_RunStatus!=NaN) || (ACATAH_FreshAirH!=NaN && ACATAH_FreshAirH!=NaN)) && (((ACATAH_FreshAirH==NaN || ACATAH_RunStatus==NaN)?false:((ACATAH_FreshAirH>=1) && (ACATAH_RunStatus==0))) || ((ACATAH_FreshAirH==NaN || ACATAH_FreshAirH==NaN)?false:((ACATAH_FreshAirH>=ACATAH_FreshAirH+1))))";

        HashMap<String, Object> paramMap = new HashMap<>();
        //		paramMap.put("ACATAH_FreshAirH", 1.0);
        paramMap.put("ACATAH_RunStatus", 0.0);
        //		paramMap.put("EnergyData", 6.125);
        //		paramMap.put("Pclose", 5.0);
        System.out.println(checkExpression(expression, paramMap));
    }
}

